dgram  =  require 'dgram'
serverSocket = dgram.createSocket 'udp4'
clientSocket = dgram.createSocket 'udp4'

ATEM_ADDR = process.env['ATEM_ADDR'] || '172.16.0.2'
ATEM_PORT = process.env['ATEM_PORT'] || 9910
listen_port = 1024 + Math.floor(Math.random() * 64511)
software_address = ""
software_port = 0

serverSocket.bind ATEM_PORT
clientSocket.bind listen_port

# From Atem Software Control
serverSocket.on 'message', (message, remote) ->
  software_address = remote.ip
  software_port = remote.port
  clientSocket.send message, 0, message.length, ATEM_PORT, ATEM_ADDR
  console.log '[CONT]', byteToString(message.slice(12)) if remote.size > 12
  # console.log parseNumber(bufferToArray(message[108..111]).reverse()) if parseString(message[16..19]) == "CKDV"
  # console.log parseNumber(bufferToArray(message[112..115])) if parseString(message[16..19]) == "CKDV"
  # console.log byteToString(message[40..43]) if parseString(message[16..19]) == "CKDV"

# From Atem Switcher
clientSocket.on 'message', (message, remote) ->
  serverSocket.send message, 0, message.length, software_port, software_address
  # console.log '[ATEM]', parseString(message[16..19]), byteToString(message.slice(12)) if remote.size > 12

byteToString = (bytes) ->
  arr = []
  for byte in bytes
    arr.push(("0" + byte.toString(16)).slice(-2))
  arr.join(' ')

parseString = (bytes) ->
  str = ''
  for char in bytes
    break if char == 0
    str += String.fromCharCode(char)
  str

parseNumber = (bytes) ->
  num = 0
  for byte, i in bytes
    num += byte
    num = num << 8 if (i < bytes.length-1)
  num

bufferToArray = (buffers) ->
  arr = []
  for buffer in buffers
    arr.push(buffer)
  arr
